import java.io.*;
import java.util.*;
import java.net.*;

public class MkTable {

    private static final String locator = "href=\"tables/";

    public static void main(String[] args) throws Exception {
        BufferedReader index = new BufferedReader(new InputStreamReader(new URL("http://www.stixfonts.org/charactertable.html")
                                                                        .openStream()));
        PrintWriter    table = new PrintWriter(new OutputStreamWriter(new FileOutputStream(args[0]), "UTF-8"));

        String iline = null;
        while( (iline = index.readLine()) != null) {

            if (iline.indexOf(locator) == -1) continue;
            iline = iline.substring(iline.indexOf(locator)+locator.length());
            iline = iline.substring(0, iline.indexOf('\"'));

            String url = "http://www.stixfonts.org/tables/"+iline;
            System.out.println();
            System.out.println("fetching " + url);
            try {
                BufferedReader in = new BufferedReader(new InputStreamReader(new URL(url).openStream()));
                String s = null;
                while( (s = in.readLine()) != null) {
                    if (s.equals("  <tr height=\"17\">")) {
                        s = in.readLine();
                        s = in.readLine().trim();
                        
                        if (s.startsWith("<td>") && s.endsWith("</td>")) {
                            s = s.substring(4);
                            s = s.substring(0, s.length()-5);
                            if (!s.startsWith("G") && !s.startsWith("M")) {
                                int code = Integer.parseInt(s, 16);
                                s = in.readLine();
                                s = in.readLine().trim();
                                if (s.startsWith("<td>\\") && s.endsWith("</td>")) {
                                    s = s.substring(4);
                                    s = s.substring(0, s.length()-5);
                                    
                                    // FIXME more
                                    s = s.replace("&amp;" , "&");
                                    System.out.println("charnum: " + code + " char: " +((char)code)+" tex: "+s);

                                    if (code >= 0x391 && code <= 0x3f6 &&
                                        s.startsWith("\\up") && Character.isUpperCase(s.charAt(3)))
                                        s = "$\\Up"+s.substring(3,4).toLowerCase()+s.substring(4)+"$";
                                    else
                                        if (s.equals("\\textquotedbl")) s = "\"";
                                    else if (s.equals("\\endash")) s = "-";
                                    else if (s.equals("\\emdash")) s = "--";
                                    else if (!s.startsWith("\\text")) s = "$"+s+"$";

                                    table.println(((char)code)+" "+Integer.toString(code,16)+ " " +s);
                                }
                            }
                        }
                    }
                }
            } catch (java.io.FileNotFoundException f) {
                System.out.println("  could not fetch");
            }
        }

        // override how small-caps are handled
        for(int i=0; i<26; i++)
            table.println( ((char)(0x1d10+i)) + " " + Integer.toString(0x1d10+i, 16) + " {\\textsc{"+((char)('A'+i))+"}}");

        // my own customizations
        for(int i=0; i<10; i++)
            table.println(((char)(0x2070+i))+" 207"+i+" ${}^{\\text{"+i+"}}$");
        table.println(((char)0x207A)+" 207A ${}^{\\text{+}}$");
        table.println(((char)0x207B)+" 207B ${}^{\\text{-}}$");
        table.println(((char)0x207C)+" 207C ${}^{\\text{=}}$");
        table.println(((char)0x207D)+" 207D ${}^{\\text{(}}$");
        table.println(((char)0x207E)+" 207E ${}^{\\text{)}}$");

        for(int i=0; i<10; i++)
            table.println(((char)(0x2080+i))+" 208"+i+" ${}_{\\text{"+i+"}}$");
        table.println(((char)0x208A)+" 208A ${}_{\\text{+}}$");
        table.println(((char)0x208B)+" 208B ${}_{\\text{-}}$");
        table.println(((char)0x208C)+" 208C ${}_{\\text{=}}$");
        table.println(((char)0x208D)+" 208D ${}_{\\text{(}}$");
        table.println(((char)0x208E)+" 208E ${}_{\\text{)}}$");

        table.println(((char)0x1d00)+" 1d00 ${}_{\\text{A}}$");
        table.println(((char)0x1d04)+" 1d04 ${}_{\\text{C}}$");
        table.println(((char)0x1d05)+" 1d05 ${}_{\\text{D}}$");
        table.println(((char)0x1d07)+" 1d07 ${}_{\\text{E}}$");
        table.println(((char)0x1d0b)+" 1d0b ${}_{\\text{K}}$");
        table.println(((char)0x1d0d)+" 1d0d ${}_{\\text{M}}$");
        table.println(((char)0x1d0f)+" 1d0f ${}_{\\text{O}}$");
        table.println(((char)0x1d18)+" 1d18 ${}_{\\text{P}}$");
        table.println(((char)0x1d1b)+" 1d1b ${}_{\\text{T}}$");
        table.println(((char)0x1d1c)+" 1d1c ${}_{\\text{U}}$");
        table.println(((char)0x1d20)+" 1d20 ${}_{\\text{V}}$");
        table.println(((char)0x1d21)+" 1d21 ${}_{\\text{W}}$");
        table.println(((char)0x1d22)+" 1d22 ${}_{\\text{Z}}$");
        table.println(((char)0x1d29)+" 1d29 ${}_{\\text{P}}$");

        table.println(((char)0x25ef)+" 25ef $\\bigcirc$");

        table.println(((char)0x220c)+" 220c /\\llap{$\\ni$}");

        table.println(((char)0x2a1f)+" 2a1f $\\fatsemi$");
        table.println(((char)0x2982)+" 2982 $\\colon$");          // this is less-than-ideal

        table.println(((char)0x00B2)+" 00b2 ${}^{\\text{2}}$");
        table.println(((char)0x00B3)+" 00b3 ${}^{\\text{3}}$");
        table.println(((char)0x00BA)+" 00ba ${}^{\\text{o}}$");
        table.println(((char)0x00B9)+" 00b9 ${}^{\\text{1}}$");

        table.println(((char)0x25cb)+" 25cb $\\circ$");

        table.flush();
        table.close();
    }

}